"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const jwt = __importStar(require("jsonwebtoken"));
const dotenv = __importStar(require("dotenv"));
dotenv.config();
function use(req, res, next) {
    return __awaiter(this, void 0, void 0, function* () {
        const authHeaders = req.headers.authorization;
        if (authHeaders && authHeaders.split(" ")[1]) {
            const token = authHeaders.split(" ")[1];
            const decoded = jwt.verify(token, process.env.SECRET);
            console.log(decoded);
            let user = null;
            if (!user) {
                throw new common_1.HttpException("User not found.", common_1.HttpStatus.UNAUTHORIZED);
            }
            req.user = user.user;
            next();
        }
        else {
            throw new common_1.HttpException("Not authorized.", common_1.HttpStatus.UNAUTHORIZED);
        }
    });
}
exports.use = use;
