"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class TokenService {
    constructor(jwtService, userService) {
        this.jwtService = jwtService;
        this.userService = userService;
    }
    decodeToken(access_token) {
        return __awaiter(this, void 0, void 0, function* () {
            const authHeaders = access_token;
            if (authHeaders && authHeaders.split(" ")[1]) {
                const token = authHeaders.split(" ")[1];
                const decoded = this.jwtService.decode(token);
                const user = yield this.userService.findByUsername(decoded.UserName);
                delete user.password;
                if (user) {
                    return {
                        success: true,
                        user,
                    };
                }
                else {
                    return {
                        success: false,
                        user: "Not Found",
                    };
                }
            }
            else {
                return {
                    success: false,
                    user: "Not Found",
                };
            }
        });
    }
}
exports.TokenService = TokenService;
