"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const moment_timezone_1 = __importDefault(require("moment-timezone"));
function getMomentUtcDate(date) {
    return __awaiter(this, void 0, void 0, function* () {
        const dat = moment_timezone_1.default.utc(date);
        const day = moment_timezone_1.default.utc(date).format("YYYY-MM-DD");
        const day_report_format = moment_timezone_1.default.utc(date).format("MM/DD/YYYY");
        const day_time = moment_timezone_1.default.utc(date).format("YYYY-MM-DD HH:mm:ss");
        const day_time_format = moment_timezone_1.default.utc(date).format("YYYY-MM-DD HH:mm");
        const time = moment_timezone_1.default.utc(date).format("h:mm A");
        const start_day = moment_timezone_1.default.utc(date).startOf("day");
        const end_day = moment_timezone_1.default.utc(date).endOf("day");
        const date_value = moment_timezone_1.default.utc(date).valueOf();
        const start_of_month = moment_timezone_1.default
            .utc(date)
            .startOf("month")
            .format("MM/DD/YYYY");
        const end_of_month = moment_timezone_1.default
            .utc(date)
            .endOf("month")
            .format("MM/DD/YYYY");
        const start_of_month_format = moment_timezone_1.default
            .utc(date)
            .startOf("month")
            .format("DD-MM-YYYY");
        const end_of_month_format = moment_timezone_1.default
            .utc(date)
            .endOf("month")
            .format("DD-MM-YYYY");
        return {
            dat,
            day,
            time,
            start_day,
            end_day,
            date_value,
            day_time,
            start_of_month,
            end_of_month,
            day_report_format,
            end_of_month_format,
            start_of_month_format,
            day_time_format,
        };
    });
}
exports.getMomentUtcDate = getMomentUtcDate;
