"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const sequelize_typescript_1 = require("sequelize-typescript");
const role_entity_1 = require("./auth/roles/entities/role.entity");
const user_role_entity_1 = require("./auth/user-roles/entities/user-role.entity");
const user_entity_1 = require("./auth/users/entities/user.entity");
const core_column_definition_entity_1 = require("./core/core-column-definitions/entities/core-column-definition.entity");
const core_column_detail_entity_1 = require("./core/core-column-details/entities/core-column-detail.entity");
const core_menu_role_entity_1 = require("./core/core-menu-roles/entities/core-menu-role.entity");
const core_menu_entity_1 = require("./core/core-menus/entities/core-menu.entity");
const core_model_column_entity_1 = require("./core/core-model-columns/entities/core-model-column.entity");
const core_model_detail_entity_1 = require("./core/core-model-details/entities/core-model-detail.entity");
const core_page_definition_entity_1 = require("./core/core-page-definitions/entities/core-page-definition.entity");
const core_script_entity_1 = require("./core/core-scripts/entities/core-script.entity");
function dbConnection(config, models) {
    return __awaiter(this, void 0, void 0, function* () {
        const initial_models = [
            user_entity_1.User,
            role_entity_1.Role,
            user_role_entity_1.UserRole,
            core_menu_entity_1.CoreMenu,
            core_script_entity_1.CoreScript,
            core_column_definition_entity_1.CoreColumnDefinition,
            core_column_detail_entity_1.CoreColumnDetail,
            core_page_definition_entity_1.CorePageDefinition,
            core_model_column_entity_1.CoreModelColumn,
            core_model_detail_entity_1.CoreModelDetail,
            core_menu_role_entity_1.CoreMenuRole
        ];
        const tables = initial_models.concat(models);
        try {
            const sequelize = new sequelize_typescript_1.Sequelize(config);
            yield sequelize
                .authenticate()
                .then(() => {
                console.log("Connection has been established successfully.");
            })
                .catch((err) => {
                console.error("Unable to connect to the database:", err);
            });
            sequelize.addModels(tables);
        }
        catch (error) {
            console.error("Unable to connect to the databases:", error);
        }
    });
}
exports.dbConnection = dbConnection;
